/***************************************************************************
                          capabilities.hpp  -  description
                             -------------------
    begin                : Tue Sep 09 2008
    copyright            : (C) 2008 by Krippel Harald
    email                : harald@hte-develop.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CAPABILITIES_H
#define CAPABILITIES_H

#include <QWidget>

#include <phonon/phononnamespace.h>
#include <phonon/audiooutput.h>
#include <phonon/seekslider.h>
#include <phonon/mediaobject.h>
#include <phonon/volumeslider.h>
#include <phonon/backendcapabilities.h>
#include <phonon/effect.h>
#include <phonon/effectparameter.h>
#include <phonon/objectdescriptionmodel.h>
#include <QList>

QT_BEGIN_NAMESPACE
class QAction;
class QGroupBox;
class QPushButton;
class QLabel;
class QListWidget;
class QListView;
class QTextEdit;
class QTreeWidget;
QT_END_NAMESPACE

class Capabilities : public QWidget
{
    Q_OBJECT

public:
        Capabilities();

private slots:
    void updateWidgets();

private:
    void setupUi();
    void setupBackendBox();

    QGroupBox *backendBox;

    QLabel *devicesLabel;
    QLabel *mimeTypesLabel;
    QLabel *effectsLabel;

    QListWidget *mimeListWidget;
    QListView *devicesListView;
    QTreeWidget *effectsTreeWidget;
};

#endif

